<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/tettri.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>tettri.c</h1><a href="tettri_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: tettri.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#a3ea39ff11354754297822b91f4922d52">00029</a> PetscReal <a class="code" href="tettri_8c.html#a3ea39ff11354754297822b91f4922d52">triarea</a>(PetscReal *v0,PetscReal *v1,PetscReal *v2,PetscReal *n)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   PetscReal a[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],b[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],outer[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00032"></a>00032   PetscReal result;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="comment">/* calculate a=v1-v0 */</span>
<a name="l00035"></a>00035   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,v1,1,a,1);
<a name="l00036"></a>00036   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,v0,1,a,1);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="comment">/* calculate b=v2-v0 */</span>
<a name="l00039"></a>00039   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,v2,1,b,1);
<a name="l00040"></a>00040   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,v0,1,b,1);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">/* result=0.5*|a x b| */</span>
<a name="l00043"></a>00043   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,a,b,outer);
<a name="l00044"></a>00044   result=0.5*<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,outer,1);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (n!=PETSC_NULL) {
<a name="l00047"></a>00047     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/(2.0*result),outer,1);
<a name="l00048"></a>00048     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,outer,1,n,1);
<a name="l00049"></a>00049   }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="keywordflow">return</span>(result);
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="util_8h.html#ad362da888961433eb994e6a5bc0c818d">00055</a> PetscReal <a class="code" href="init_8h.html#ad362da888961433eb994e6a5bc0c818d">tetvol</a>(PetscReal *x1,PetscReal *x2,PetscReal *x3,PetscReal *x4)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   PetscReal result;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">/* Calculate volume of the element */</span>
<a name="l00060"></a>00060   result=(1.0/6.0)*
<a name="l00061"></a>00061     (x3[0]*x2[1]*x1[2] - x4[0]*x2[1]*x1[2] - x2[0]*x3[1]*x1[2] + x4[0]*x3[1]*x1[2] +
<a name="l00062"></a>00062      x2[0]*x4[1]*x1[2] - x3[0]*x4[1]*x1[2] - x3[0]*x1[1]*x2[2] + x4[0]*x1[1]*x2[2] +
<a name="l00063"></a>00063      x1[0]*x3[1]*x2[2] - x4[0]*x3[1]*x2[2] - x1[0]*x4[1]*x2[2] + x3[0]*x4[1]*x2[2] +
<a name="l00064"></a>00064      x2[0]*x1[1]*x3[2] - x4[0]*x1[1]*x3[2] - x1[0]*x2[1]*x3[2] + x4[0]*x2[1]*x3[2] +
<a name="l00065"></a>00065      x1[0]*x4[1]*x3[2] - x2[0]*x4[1]*x3[2] - x2[0]*x1[1]*x4[2] + x3[0]*x1[1]*x4[2] +
<a name="l00066"></a>00066      x1[0]*x2[1]*x4[2] - x3[0]*x2[1]*x4[2] - x1[0]*x3[1]*x4[2] + x2[0]*x3[1]*x4[2]
<a name="l00067"></a>00067     );
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="keywordflow">return</span>(result);
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="util_8h.html#aa5edf1170e954574fb88dff3cafac7c1">00072</a> <span class="keywordtype">int</span> <a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(<span class="keywordtype">int</span> *tet1, <span class="keywordtype">int</span> *tet2, <span class="keywordtype">int</span> *vshared)
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   <span class="keywordtype">int</span> t1[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>],t2[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>];
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;i++) {
<a name="l00077"></a>00077     t1[i]=tet1[i];
<a name="l00078"></a>00078     t2[i]=tet2[i];
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">/* sort nodes */</span>
<a name="l00082"></a>00082   PetscSortInt(NV,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)t1);
<a name="l00083"></a>00083   PetscSortInt(NV,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)t2);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordtype">int</span> cntshared=0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;NV;i++) {
<a name="l00088"></a>00088     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00089"></a>00089       <span class="keywordflow">if</span> (t1[i]==t2[j]) {
<a name="l00090"></a>00090         <span class="keywordflow">if</span> (vshared!=PETSC_NULL) vshared[cntshared]=t1[i];
<a name="l00091"></a>00091         cntshared++;
<a name="l00092"></a>00092       }
<a name="l00093"></a>00093     }
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   assert(cntshared&lt;=NV);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">return</span>(cntshared);
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="util_8h.html#a62d7f69412ba9d0be81b6d815062456b">00101</a> <span class="keywordtype">int</span> <a class="code" href="tettri_8c.html#a62d7f69412ba9d0be81b6d815062456b">TetSharedVertices</a>(<span class="keywordtype">int</span> *v1,<span class="keywordtype">int</span> *v2,<span class="keywordtype">int</span> *s)
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   <span class="keywordtype">int</span> k;
<a name="l00104"></a>00104   k=0;
<a name="l00105"></a>00105   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;i++) {
<a name="l00106"></a>00106     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00107"></a>00107       <span class="keywordflow">if</span> (v1[i]==v2[j]) {
<a name="l00108"></a>00108         s[k]=v1[i];
<a name="l00109"></a>00109         k++;
<a name="l00110"></a>00110         <span class="keywordflow">continue</span>;
<a name="l00111"></a>00111       }
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113   }
<a name="l00114"></a>00114   <span class="keywordflow">return</span>(k);
<a name="l00115"></a>00115 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

